#!/bin/bash

IDE=`ls -1 /dev/hd? 2>/dev/null | cut -d "/" -f 3`
SATA=`ls -1 /dev/sd? | cut -d "/" -f 3`

MAX=0
MIN=100

for x in $SATA $IDE
do
	declare $x="`smartctl --attributes -d ata /dev/$x | grep Temperature_Celsius | cut -d " " -f 37`"
	if [ ! -z $x ]
	then
 		VAR=$(eval echo " \$$x")
		if [ "$VAR" -gt "$MAX" ]
		then
			MAX="$VAR"
		fi
		
		if [ "$VAR" -lt "$MIN" ]
		then
			MIN="$VAR"
		fi
	else
		declare $x=xx
	fi
done


RANGE=`eval echo {$MIN..$MAX}`

DISTINCT=0
for x in $RANGE
do
	((DISTINCT++))
done	
STEP=$((DISTINCT / 4))

function colour_var () {

	TMPVAR="$1"
	COLOUR="$2"
	RESET=WHITE

	LRED="\033[1;31m"
	DRED="\033[31m"
	LBLUE="\033[1;34m"
	DBLUE="\033[34m"
	LGREEN="\033[1;32m"
	DGREEN="\033[32m"
	LYELLOW="\033[1;33m"
	DYELLOW="\033[33m"
	WHITE="\033[0m"

	TMP="\$$COLOUR \$$TMPVAR \033[0m"
	ABC=$(eval echo -e "\$$COLOUR\$$TMPVAR\$$RESET")
	export $TMPVAR="$ABC"
}

for x in $SATA
do
	VAR=$(eval echo " \$$x")
	
	if [ "$VAR" -ge "$MAX" ]
	then
		colour_var $x LRED
	fi
	if [ "$VAR" -lt "$MAX" ] && [ "$VAR" -gt "$((MAX-$STEP))" ]
	then
		colour_var $x DRED
	fi
	if [ "$VAR" -le "$((MAX-$STEP))" ] && [ "$VAR" -gt "$((MAX-$STEP*2))" ]
	then
		colour_var $x LYELLOW
	fi
	if [ "$VAR" -le "$((MAX-$STEP*2))" ] && [ "$VAR" -gt "$((MAX-$STEP*3))" ]
	then
		colour_var $x DYELLOW
	fi
	if [ "$VAR" -le "$((MAX-$STEP*3))" ] && [ "$VAR" -gt "$((MAX-$STEP*4))" ]
	then
		colour_var $x LGREEN
	fi
	if [ "$VAR" -le "$MIN" ] || [ "$VAR" -le "$((MAX-$STEP*4))" ]
	then
		colour_var $x DGREEN
	fi
done

echo -e " -- $sda -- | -- $sdb --"
echo -e "| $sdf | $sde | $sdd | $sdc |"
echo -e "| $sdj | $sdi | $sdh | $sdg |"
echo -e "| $sdn | $sdm | $sdl | $sdk |"
echo -e "| $sdr | $sdq | $sdp | $sdo |"
echo -e "| $sdv | $sdu | $sdt | $sds |"
